unit variables1;
{
Copyright (C) 2005 Patrick Chevalley

http://www.astrosurf.com/astropc
pch@freesurf.ch

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

interface

uses Sky_DDE_Util, Clipbrd,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, ToolEdit, ComCtrls, Buttons,IniFiles,ShellAPI,
  Menus, ExtCtrls, SortGrid, Grids, DdeMan;

type
  TVarForm = class(TForm)
    PrinterSetupDialog1: TPrinterSetupDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Open1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SortGrid1: TSortGrid;
    Setting1: TMenuItem;
    Help1: TMenuItem;
    Print1: TMenuItem;
    Printersetup1: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    PopupMenu1: TPopupMenu;
    Lightcurve1: TMenuItem;
    Enterobservation1: TMenuItem;
    ShowChart1: TMenuItem;
    Edit3: TMenuItem;
    Editcurrentfile1: TMenuItem;
    Editobservationfile1: TMenuItem;
    Newobservation1: TMenuItem;
    Content1: TMenuItem;
    Timer1: TTimer;
    DdeClientConv1: TDdeClientConv;
    DdeClientItem1: TDdeClientItem;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    BitBtn1: TBitBtn;
    DateTimePicker2: TDateTimePicker;
    Edit1: TEdit;
    Edit2: TEdit;
    RadioGroup1: TRadioGroup;
    Edit4: TEdit;
    BitBtn3: TBitBtn;
    About1: TMenuItem;
    DateTimePicker1: TDateTimePicker;
    AAVSOTools1: TMenuItem;
    PrepareLPVBulletin1: TMenuItem;
    Createobservingplan1: TMenuItem;
    AAVSOwebpage1: TMenuItem;
    N1: TMenuItem;
    AAVSOChart1: TMenuItem;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SortGrid1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Setting1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Print1Click(Sender: TObject);
    procedure Printersetup1Click(Sender: TObject);
    procedure Lightcurve1Click(Sender: TObject);
    procedure ShowChart1Click(Sender: TObject);
    procedure Editcurrentfile1Click(Sender: TObject);
    procedure Editobservationfile1Click(Sender: TObject);
    procedure Newobservation1Click(Sender: TObject);
    procedure Content1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure DateTimePicker1Change(Sender: TObject);
    procedure PrepareLPVBulletin1Click(Sender: TObject);
    procedure Createobservingplan1Click(Sender: TObject);
    procedure AAVSOwebpage1Click(Sender: TObject);
    procedure AAVSOChart1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

function datef(jdt:double): string;
function Jd(annee,mois,jour :integer; Heure:double):double;
PROCEDURE Djd(jd:Double;VAR annee,mois,jour:integer; VAR Heure:double);
function words(str,sep : string; p,n : integer) : string;
function IsNumber(n : string) : boolean;
Function Slash(n : string) : string;
Function SlashX(n : string) : string;
Function SetDate(year,month,day : word) : Tdatetime;
Procedure GetDate(d : TDatetime; var year,month,day : word);
Function ExecuteFile(const FileName, Params, DefaultDir: string; ShowCmd: Integer): THandle;

Type
    TVarinfo = class(Tobject)
                i : array[1..13] of double;
                end;
var
  VarForm: TVarForm;
  datim,datact,qlurl,qlmethode,qlinfo,vsurl,vsmethode,vsinfo,afoevurl,afoevmethode,afoevinfo,pcobscaption : string;
  lockdate : boolean = false;
  lockselect : boolean = false;
  started : boolean = false;
  AppDir,fname : string;
  maxvar : integer = 5000;
  jdact : double;
  CurrentRow: integer;
  param : Tstringlist;
  OldWindowProc : Pointer; {Variable for the old windows proc}
  MyMsg : DWord; {custom systemwide message}
  StartedByVarobs : boolean = false;
  NoChart : boolean = false;
  CielHnd : Thandle;

const bl='                                         ';
abrcons=' And Ant Aps Aqr Aql Ara Ari Aur Boo Cae Cam Cnc CVn CMa CMi Cap Car Cas Cen Cep Cet Cha Cir Col Com CrA CrB Crv Crt Cru'
       +' Cyg Del Dor Dra Equ Eri For Gem Gru Her Hor Hya Hyi Ind Lac Leo LMi Lep Lib Lup Lyn Lyr Men Mic Mon Mus Nor Oct Oph Ori'
       +' Pav Peg Per Phe Pic Psc PsA Pup Pyx Ret Sge Sgr Sco Scl Sct Ser Ser Sex Tau Tel Tri TrA Tuc UMa UMi Vel Vir Vol Vul ';

greek : array[1..2,1..24]of string=(('alpha','beta','gamma','delta','epsilon','zeta','eta','theta','iota','kappa','lambda','mu','nu','zi','omicron','pi','rho','sigma','tau','upsilon','phi','chi','psi','omega'),
                          ('alp','bet','gam','del','eps','zet','eta','the','iot','kap','lam','mu','nu','zi','omi','pi','rho','sig','tau','ups','phi','chi','psi','ome'));

pulslist=' ACYG BCEP BCEPS BLBOO CEP CEP(B) CW CWA CWB DCEP DCEPS DSCT DSCTC L LB LC M PVTEL RR RR(B) RRAB RRC RV RVA RVB SR SRA SRB SRC SRD SXPHE ZZ ZZA ZZB ZZO ';
rotlist=' ACV ACVO BY ELL FKCOM PSR SXARI ';
ecllist=' E EA EB EW GS PN RS WD WR AR D DM DS DW K KE KW SD ';

aavsocharturl='http://www.aavso.org/cgi-bin/shrinkwrap.pl?path=/';

implementation

Uses detail1,settingunit,obsunit, splashunit, aavsochart ;

{$R *.DFM}

Procedure FreeInfo(var gr : TSortgrid);
var i : integer;
begin
with gr do
  if rowcount>=2 then
    for i:=2 to rowcount-1 do
        Objects[0,i].Free;
end;

function nextword(var buf : string) : string;
var p : integer;
begin
p:=pos(',',buf);
if p=0 then p:=length(buf)+1;
result:=copy(buf,1,p-1);
buf:=copy(buf,p+1,999);
end;

function words(str,sep : string; p,n : integer) : string;
var     i,j : Integer;
begin
result:='';
str:=trim(str);
for i:=1 to p-1 do begin
 j:=pos(' ',str);
 if j=0 then j:=length(str)+1;
 str:=trim(copy(str,j,length(str)));
end;
for i:=1 to n do begin
 j:=pos(' ',str);
 if j=0 then j:=length(str)+1;
 result:=result+trim(copy(str,1,j))+sep;
 str:=trim(copy(str,j,length(str)));
end;
end;

Function ExecuteFile(const FileName, Params, DefaultDir: string; ShowCmd: Integer): THandle;
var
  zFileName, zParams, zDir: array[0..79] of Char;
begin
  Result := ShellExecute(Application.MainForm.Handle, nil, StrPCopy(zFileName, FileName),
                         StrPCopy(zParams, Params), StrPCopy(zDir, DefaultDir), ShowCmd);
end;

function IsNumber(n : string) : boolean;
var i,dummy : integer;
begin
val(n,dummy,i);
result:= (i=0) ;
end;

Function Slash(n : string) : string;
begin
if copy(n,length(n),1)<>'\' then result:=n+'\'
                            else result:=n;
end;

Function SlashX(n : string) : string;
begin
if copy(n,length(n),1)<>'/' then result:=n+'/'
                            else result:=n;
end;

function Jd(annee,mois,jour :integer; Heure:double):double;
 VAR siecle,cor:INTEGER ;
     jd1:double;
 BEGIN
    IF mois<=2 THEN
    begin
      annee:=annee-1;
      mois:=mois+12;
    end ;
    (* IF (annee>1582) OR ((annee=1582) AND ((mois*100+jour)>=1015)) THEN *)
    IF annee > 1582 THEN
    begin
       siecle:=annee DIV 100;
       cor:=2 - siecle + siecle DIV 4;
       end
        ELSE
        cor:=0;
    IF annee<0 THEN
       jd1:=Int(365.25*annee-0.75)
     ELSE
       jd1:=Int(365.25*annee);
    jd := jd1 + Int(30.6001*(mois+1)) + jour
               + 1720994.5 + cor + Heure/24.0;
 END ;

PROCEDURE Djd(jd:Double;VAR annee,mois,jour:integer; VAR Heure:double);
 VAR z,f,a,al,b,c,d,e:double;
 BEGIN
    z := Int(jd+0.5);
    f := jd + 0.5 - z ;
    IF z<2299161.0 THEN
       a := z
      ELSE
      begin
       al:= Int((z-1867216.25)/36524.25);
        a := z + 1.0 + al - Int(al/4.0);
    END;
    b := a + 1524.0;
    c := Int((b-122.1)/365.25);
    d := Int(365.25*c);
    e := Int((b-d)/30.6001);
    jour := Trunc(b-d-Int(30.6001*e)+f);
    IF e<13.5 THEN
        mois:=Trunc(e)-1
      ELSE
        mois:=Trunc(e)-13;
    IF mois>2 THEN
        annee:=Trunc(c)-4716
      ELSE
        annee:=Trunc(c)-4715;
    IF (annee MOD 4 <> 0) AND (mois=2) AND (jour=29) THEN
    begin
            mois:=3;
            jour:=1;
    END;
    Heure:=24.0*f ;
 END ;

Procedure GetDate(d : Tdatetime; var year,month,day : word);
var s : TSystemTime;
begin
   DateTimeToSystemTime(d,s);
   year:=s.wYear;
   month:=s.wMonth;
   day:=s.wDay;
end;

Function SetDate(year,month,day : word) : Tdatetime;
var s : TsystemTime;
begin
s.wYear:=year ;
s.wMonth:=month ;
s.wDayOfWeek:=0 ;
s.wDay:=day ;
s.wHour:=0 ;
s.wMinute:=0 ;
s.wSecond:=0 ;
s.wMilliseconds:=0 ;
result:=SystemTimeToDateTime(s);
end;

Procedure PulsVar(jdobs,magmax,magmin,jdini,period,rise : double; var actmag,prevmini,prevmaxi,nextmini,nextmaxi,next2mini: double);
var risep : double;
begin
nextmaxi:=jdini;
if jdobs>jdini then begin
   repeat
         nextmaxi:=nextmaxi+period;
   until nextmaxi>jdobs;
end else begin
   repeat
         nextmaxi:=nextmaxi-period;
   until nextmaxi<jdobs;
   nextmaxi:=nextmaxi+period;
end;
risep:=period*rise/100;
nextmini:=nextmaxi-risep;
prevmini:=nextmini-period;
prevmaxi:=nextmaxi-period;
next2mini:=nextmini+period;
if jdobs<nextmini then
     actmag:=magmax+(jdobs-prevmaxi)*(magmin-magmax)/(period-risep)
else
     actmag:=magmin-(jdobs-nextmini)*(magmin-magmax)/risep;
end;

Procedure EcliVar(jdobs,magmax,magmin,jdini,period,rise : double; var actmag,prevmini,prev2maxi,prevmaxi,nextmini,nextmaxi,next2maxi,next2mini: double);
var risep : double;
begin
nextmini:=jdini;
if jdobs>jdini then begin
   repeat
         nextmini:=nextmini+period;
   until nextmini>jdobs;
end else begin
   repeat
         nextmini:=nextmini-period;
   until nextmini<jdobs;
   nextmini:=nextmini+period;
end;
risep:=period*rise/100/2;
prevmini:=nextmini-period;
next2mini:=nextmini+period;
nextmaxi:=nextmini+risep;
prevmaxi:=nextmini-risep;
prev2maxi:=prevmini+risep;
next2maxi:=next2mini-risep;
if (jdobs<prev2maxi) then actmag:=magmin-(jdobs-prevmini)*(magmin-magmax)/risep
else if (jdobs<prevmaxi) then actmag:=magmax
else if (jdobs<nextmini) then actmag:=magmax+(jdobs-prevmaxi)*(magmin-magmax)/risep
else if (jdobs<nextmaxi) then actmag:=magmin-(jdobs-nextmini)*(magmin-magmax)/risep
else if (jdobs<next2maxi) then actmag:=magmax
else actmag:=magmax+(jdobs-next2maxi)*(magmin-magmax)/risep;
end;

function datef(jdt:double): string;
var yy,mm,dd : integer;
    hm : double;
begin
case varform.RadioGroup1.ItemIndex of
0 : begin
    djd(jdt,yy,mm,dd,hm);
    result:=formatdatetime('yyyy-mm-dd hh:mm:ss',encodedate(yy,mm,dd)+hm/24);
    end;
1 : begin
    str(jdt:9:4,result);
    end;
2 : begin
    djd(jdt,yy,mm,dd,hm);
    str((hm/24):1:4,result);
    result:=formatdatetime('yyyymmdd',encodedate(yy,mm,dd))+copy(result,2,9);
    end;
end;
end;

Procedure Errmsg(m1,m2 : string);
begin
showmessage('Missing value for '+m1+'  '+m2);
end;

Procedure CalculVar;
var f : textfile;
  ww,buf,name,vtype,design : string;
  yy,mm,dd,r,curvtype,p : integer;
  hh,mi,ss,mss,y1,m1,d1 : word;
  magmax,magmin,jdini,period,rise,actmag,next2mini,nextmini,nextmaxi,next2maxi,prevmini,prevmaxi,prev2maxi,hm : double;
  aavsodesign,uncertain : boolean;
  varinfo : Tvarinfo;
begin
if not fileexists(fname) then begin
   Showmessage('File not found : '+fname);
   exit;
end;
FreeInfo(VarForm.SortGrid1);
varform.caption:='Variables Star Observer, current file : '+extractfilename(fname);
VarForm.SortGrid1.RowCount:=2;
VarForm.SortGrid1.Cells[0,0]:='Name';
VarForm.SortGrid1.Cells[1,0]:='Design.';
VarForm.SortGrid1.Cells[2,0]:='Type';
VarForm.SortGrid1.Cells[3,0]:='Max.';
VarForm.SortGrid1.Cells[4,0]:='Min.';
VarForm.SortGrid1.Cells[5,0]:='Actual';
VarForm.SortGrid1.Cells[6,0]:='Minima';
VarForm.SortGrid1.Cells[7,0]:='Maxima';
VarForm.SortGrid1.Cells[8,0]:='Minima';
VarForm.SortGrid1.Cells[9,0]:='Maxima';
VarForm.SortGrid1.Cells[10,0]:='Minima';
screen.cursor:=crhourglass;
aavsodesign:=false;
try
r:=1;
assignfile(f,fname);
reset(f);
getdate(varform.Datetimepicker1.date,y1,m1,d1);
decodetime(varform.datetimepicker2.time,hh,mi,ss,mss);
datim:=formatdatetime('yyyy-mm-dd',varform.Datetimepicker1.date);
datim:=datim+'  '+formatdatetime('hh:mm',varform.datetimepicker2.time)+' UT';
yy:=y1 ; mm:=m1 ; dd:=d1;
hm:=hh+mi/60+ss/3600;
jdact:=jd(yy,mm,dd,hm);
datact:=datef(jdact);
repeat
uncertain:=false;
readln(f,buf);
if trim(buf)='' then continue;
if buf[1]=';' then continue;
name:=nextword(buf);
if name='ENDOFLIST' then continue;
name:=trim(words(name,'',1,1)+' '+words(name,'',2,1)+' '+words(name,'',3,1)+' '+words(name,'',4,99));
vtype:=trim(nextword(buf));
curvtype:=0;
ww:=vtype;
p:=pos('+',ww);                 // keep only first type
if p>0 then ww:=copy(ww,1,p-1);
p:=pos('/',ww);
if p>0 then ww:=copy(ww,1,p-1);
p:=pos(':',ww);
if p>0 then ww:=copy(ww,1,p-1);
ww:=trim(ww);
if pos(' '+ww+' ',pulslist)>0 then curvtype:=1;
if pos(' '+ww+' ',rotlist)>0 then curvtype:=1;
if pos(' '+ww+' ',ecllist)>0 then curvtype:=2;
ww:=trim(nextword(buf));
if ww<>'' then magmax:=strtofloat(ww)
          else begin magmax:=0; uncertain:=true; end;
ww:=trim(nextword(buf));
if ww<>'' then magmin:=strtofloat(ww)
          else begin magmin:=16; uncertain:=true; end;
ww:=trim(nextword(buf));
if ww<>'' then jdini:=strtofloat(ww)
          else begin
             curvtype:=0;
             jdini:=jdact;
          end;
ww:=trim(nextword(buf));
if ww<>'' then period:=strtofloat(ww)
          else begin
             curvtype:=0;
             period:=100;
          end;
ww:=trim(nextword(buf));
if ww<>'' then rise:=strtofloat(ww)
          else begin
               if copy(vtype,1,1)='E' then rise:=5 else rise:=50;
               uncertain:=true;
               end;
if (length(ww)=3)and(pos('.',ww)=0) then rise:=rise/10; // bizarerie du gcvs pour les EA          
if (vtype='RV') or (vtype='RVA') or (vtype='RVB') then begin  // minima for RV Tau
   jdini:=jdini+period*rise/100;                        // convert to maxima
end;
ww:=trim(nextword(buf));
if ww<>'' then design:=ww
          else design:='';
if magmax=magmin then begin magmin:=magmin+0.001; uncertain:=true; end;
next2maxi:=0; prev2maxi:=0;
case curvtype of
1 : PulsVar(jdact,magmax,magmin,jdini,period,rise,actmag,prevmini,prevmaxi,nextmini,nextmaxi,next2mini);
2 : EcliVar(jdact,magmax,magmin,jdini,period,rise,actmag,prevmini,prev2maxi,prevmaxi,nextmini,nextmaxi,next2maxi,next2mini);
else begin
     actmag:=-9999;
     prevmini:=0;
     prevmaxi:=0;
     nextmini:=0;
     nextmaxi:=0;
     next2mini:=0;
     end;
end;
varform.SortGrid1.RowCount:=r+1;
buf:=trim(name);
varform.SortGrid1.Cells[0,r]:=buf;
buf:=trim(design);
if buf<>'' then aavsodesign:=true;
varform.SortGrid1.Cells[1,r]:=buf;
buf:=trim(vtype);
varform.SortGrid1.Cells[2,r]:=buf;
str(magmax:5:2,buf);
varform.SortGrid1.Cells[3,r]:=buf;
str(magmin:5:2,buf);
varform.SortGrid1.Cells[4,r]:=buf;
varinfo := Tvarinfo.Create;
if actmag>-999 then begin
   str(actmag:2:0,buf);
   if uncertain then buf:=buf+'?';
   varform.SortGrid1.Cells[5,r]:=buf;
   varinfo.i[3]:=actmag;
end else begin
   varform.SortGrid1.Cells[5,r]:='-';
   varinfo.i[3]:=magmin;
end;
if prevmini>0 then begin
                   varform.SortGrid1.Cells[6,r]:=datef(prevmini);
                   varinfo.i[4]:=prevmini;
              end else begin
                  varform.SortGrid1.Cells[6,r]:='-';
                  varinfo.i[4]:=jdact-period;
              end;
if prev2maxi>0 then begin
                   varinfo.i[12]:=prev2maxi;
              end else begin
                   varinfo.i[12]:=0;
              end;
if prevmaxi>0 then begin
                   varform.SortGrid1.Cells[7,r]:=datef(prevmaxi);
                   varinfo.i[5]:=prevmaxi;
              end else begin
                   varform.SortGrid1.Cells[7,r]:='-';
                   varinfo.i[5]:=jdact-period/2;
              end;
if nextmini>0 then begin
                   varform.SortGrid1.Cells[8,r]:=datef(nextmini);
                   varinfo.i[6]:=nextmini;
              end else begin
                   varform.SortGrid1.Cells[8,r]:='-';
                   varinfo.i[6]:=jdact;
              end;
if nextmaxi>0 then begin
                   varform.SortGrid1.Cells[9,r]:=datef(nextmaxi);
                   varinfo.i[7]:=nextmaxi;
              end else begin
                   varform.SortGrid1.Cells[9,r]:='-';
                   varinfo.i[7]:=jdact+period/2;
              end;
if next2maxi>0 then begin
                   varinfo.i[13]:=next2maxi;
              end else begin
                   varinfo.i[13]:=0;
              end;
if next2mini>0 then begin
                    varform.SortGrid1.Cells[10,r]:=datef(next2mini);
                    varinfo.i[8]:=next2mini;
              end else begin
                    varform.SortGrid1.Cells[10,r]:='-';
                    varinfo.i[8]:=jdact+period;
              end;
varinfo.i[1]:=magmax;
varinfo.i[2]:=magmin;
varinfo.i[9]:=period;
varinfo.i[10]:=rise;
varinfo.i[11]:=curvtype;
varform.SortGrid1.Objects[0,r]:=varinfo;
inc(r);
until eof(f);
if aavsodesign then varform.SortGrid1.ColWidths[1]:=60
               else varform.SortGrid1.ColWidths[1]:=0;
finally
closefile(f);
screen.cursor:=crdefault;
end;
end;

procedure TVarForm.BitBtn1Click(Sender: TObject);
begin
CalculVar;
end;

Procedure ReadParam;
var i : integer;
    buf : string;
begin
i:=0;
while i <= param.count-1 do begin
if param[i]='-c' then begin
     inc(i);
     buf:=param[i];
     if fileexists(buf) then fname:=buf;
end
else if param[i]='-n' then begin
     NoChart:=true;
end
else if pos('.var',param[i])>0 then begin
     buf:=param[i];
     if fileexists(buf) then fname:=buf;
end;
inc(i);
end;
end;

function NewWindowProc(WindowHandle : hWnd;
                       TheMessage   : Dword;
                       ParamW       : LongInt;
                       ParamL       : LongInt) : LongInt stdcall;
var
    buf : string;
    f : textfile;
begin
  if TheMessage = MyMsg  then begin
    try
   {Tell the application to restore, let it restore the form}
    SendMessage(Application.handle, WM_SYSCOMMAND, SC_RESTORE, 0);
    SetForegroundWindow(Application.Handle);
    if ParamW > 0 then begin
       chdir(appdir);
       assignfile(f,'@@param@@');
       reset(f);
       param.Clear;
       while not eof(f) do begin
          readln(f,buf);
          param.add(buf);
       end;
       Closefile(f);
       deletefile('@@param@@');
       ReadParam;
       CalculVar;
    end;
    finally
   {We handled the message - we are done}
    Result := 0;
    end;
    exit;
  end;
 {Call the original winproc}
  Result := CallWindowProc(OldWindowProc,
                           WindowHandle,
                           TheMessage,
                           ParamW,
                           ParamL);
end;

procedure TVarForm.FormCreate(Sender: TObject);
begin
 {Register a custom windows message}
  MyMsg := RegisterWindowMessage('AstroPC_VarObs');
 {Set form1's windows proc to ours and remember the old window proc}
  OldWindowProc := Pointer(SetWindowLong(VarForm.Handle,
                                         GWL_WNDPROC,
                                         LongInt(@NewWindowProc)));
param:=Tstringlist.Create;
AppDir:=slash(trim(GetCurrentDir));
decimalseparator:='.';
DateSeparator:='-';
ShortdateFormat:='yyyy-mm-dd';
SortGrid1.ColWidths[0]:=60;
SortGrid1.ColWidths[1]:=60;
SortGrid1.ColWidths[2]:=45;
SortGrid1.ColWidths[3]:=35;
SortGrid1.ColWidths[4]:=35;
SortGrid1.ColWidths[5]:=30;
//setlength(varinfo,maxvar);
end;

procedure TVarForm.Exit1Click(Sender: TObject);
begin
VarForm.close;
end;

procedure TVarForm.Edit1Change(Sender: TObject);
var
    yy,mm,dd :integer;
    hm : double;
    buf1,buf : string;
begin
if lockdate then begin lockdate:=false; exit; end;
try
djd(strtofloat(edit1.text),yy,mm,dd,hm);
if (yy>1) and (yy<9999) then begin
edit1.color:=clWindow;
lockdate:=true;
varform.Datetimepicker1.date:=setdate(yy,mm,dd);
lockdate:=true;
varform.datetimepicker2.time:=hm/24;
buf1:=format('%.4d%.2d%.2d',[yy,mm,dd]);
str(frac(varform.datetimepicker2.time):1:4,buf);
lockdate:=true;
edit2.text:=buf1+copy(buf,2,9);
edit2.color:=clWindow;
end else begin
  edit1.color:=clRed;
end;
except
  edit1.color:=clRed;
end;
Application.processmessages;
lockdate:=false;
end;

procedure TVarForm.Edit2Change(Sender: TObject);
var
    yy,mm,dd,p :integer;
    hm : double;
    buf : string;
begin
if lockdate then begin lockdate:=false; exit; end;
try
buf:=trim(edit2.text);
p:=pos('.',buf);
if p=0 then p:=length(buf);
if p<5 then begin edit2.color:=clRed; exit; end;
yy:=strtoint(copy(buf,1,p-5));
mm:=strtoint(copy(buf,p-4,2));
dd:=strtoint(copy(buf,p-2,2));
hm:=strtofloat(copy(buf,p,9))*24;
if (yy>1) and (yy<9999) then begin
edit2.color:=clWindow;
lockdate:=true;
varform.DateTimePicker1.date:=setdate(yy,mm,dd);
lockdate:=true;
varform.datetimepicker2.time:=hm/24;
str(jd(yy,mm,dd,hm):9:4,buf);
lockdate:=true;
edit1.text:=buf;
end else begin
  edit2.color:=clRed;
end;
except
  edit2.color:=clRed;
end;
Application.processmessages;
lockdate:=false;
end;

procedure TVarForm.Open1Click(Sender: TObject);
begin
try
opendialog1.FilterIndex:=3;
if opendialog1.execute then begin
   fname:=opendialog1.FileName;
   varform.caption:='Variables Star Observer, current file : '+fname;
   chdir(appdir);
   CalculVar;
end;
finally
chdir(appdir);
end;
end;

procedure TVarForm.FormShow(Sender: TObject);
var  inifile : Tinifile;
     section : string;
     year,month,day : word;
     i : integer;
begin
datetimepicker2.time:=now;
decodedate(now,year,month,day);
DateTimePicker1.date:=now;
SortGrid1.SetSelectRow(0,true);
fname:=appdir+'aavsoeasy.txt';
qlurl:='http://www.aavso.org/cgi-bin/quickquick.pl?star=$$$$';
qlmethode:='GET';
qlinfo:='http://www.aavso.org/ql';
vsurl:='http://www.kusastro.kyoto-u.ac.jp/vsnet/etc/searchobs.cgi?text=$$$$';
vsmethode:='GET';
vsinfo:='http://www.kusastro.kyoto-u.ac.jp/vsnet/etc/searchobs.html';
afoevurl:='ftp://cdsarc.u-strasbg.fr/pub/afoev/';
afoevmethode:='GET';
afoevinfo:='http://cdsweb.u-strasbg.fr/afoev/english.htx';
pcobscaption:='PCObs Data Entry';
Optform.DirectoryEdit2.Text:=aavsocharturl;
inifile:=Tinifile.create(appdir+'puls.ini');
section:='Default';
if Inifile.SectionExists(section) then begin
with inifile do begin
    fname:=ReadString(section,'fname',fname);
    Radiogroup1.itemindex:=ReadInteger(section,'dateformat',0);
    OptForm.Radiogroup1.itemindex:=ReadInteger(section,'obstype',0);
    OptForm.Radiogroup4.itemindex:=ReadInteger(section,'obsformat',0);
    OptForm.Radiogroup5.itemindex:=ReadInteger(section,'obspgm',0);
    OptForm.Radiogroup6.itemindex:=ReadInteger(section,'onlinedata',0);
    OptForm.FilenameEdit8.text:=ReadString(section,'pcobs','pcobs.exe');
    pcobscaption:=ReadString(section,'pcobscaption',pcobscaption);
    OptForm.FilenameEdit6.text:=ReadString(section,'faavsosum','aavsosum.txt');
    OptForm.FilenameEdit7.text:=ReadString(section,'faavsoql','aavsoql.txt');
    OptForm.FilenameEdit0.text:=ReadString(section,'faavsojd','aavsojd.txt');
    OptForm.FilenameEdit1.text:=ReadString(section,'faavsout','aavsout.txt');
    OptForm.FilenameEdit2.text:=ReadString(section,'fvsnet','observation.txt');
    OptForm.DirectoryEdit1.text:=ReadString(section,'dafoev','c:\afoev');
    OptForm.FilenameEdit4.text:=ReadString(section,'freeformat','vsnet.txt');
    OptForm.FilenameEdit5.text:=ReadString(section,'skychartprof','');
    OptForm.FilenameEdit3.text:=ReadString(section,'fobs','aavsosum.txt');
    OptForm.Edit1.text:=ReadString(section,'namepos','1');
    OptForm.Edit2.text:=ReadString(section,'datepos','2');
    OptForm.Edit3.text:=ReadString(section,'magpos','3');
    OptForm.Radiogroup2.itemindex:=ReadInteger(section,'datetype',1);
    OptForm.Radiogroup3.itemindex:=ReadInteger(section,'formattype',0);
    Optform.DirectoryEdit2.Text:=ReadString(section,'aavsochartdir',aavsocharturl);
    DetailForm.Checkbox1.Checked:=ReadBool(section,'followcurve',true);
    DetailForm.Checkbox2.Checked:=ReadBool(section,'plotobs',true);
    DetailForm.Checkbox3.Checked:=ReadBool(section,'owncolor',true);
    DetailForm.Checkbox4.Checked:=ReadBool(section,'plotql',false);
    DetailForm.Checkbox5.Checked:=ReadBool(section,'plotgroup',false);
    OptForm.Edit4.text:=ReadString(section,'observer','');
    DetailForm.Shape1.Brush.Color:=ReadInteger(section,'color1',clBlack);
    DetailForm.Shape2.Brush.Color:=ReadInteger(section,'color2',clWhite);
    DetailForm.Shape3.Brush.Color:=ReadInteger(section,'color3',clRed);
    DetailForm.Shape4.Brush.Color:=ReadInteger(section,'color4',clAqua);
    DetailForm.Shape5.Brush.Color:=ReadInteger(section,'color5',clRed);
    DetailForm.Shape6.Brush.Color:=ReadInteger(section,'color6',clLime);
    DetailForm.Shape7.Brush.Color:=ReadInteger(section,'color7',clYellow);
    DetailForm.Shape8.Brush.Color:=ReadInteger(section,'color8',clBlue);
    DetailForm.Shape9.Brush.Color:=ReadInteger(section,'color9',clGreen);
    DetailForm.Shape10.Brush.Color:=ReadInteger(section,'color10',clTeal);
    Varform.top:=ReadInteger(section,'formtop',Varform.top);
    Varform.left:=ReadInteger(section,'formleft',Varform.left);
    Varform.width:=ReadInteger(section,'formwidth',Varform.width);
    Varform.height:=ReadInteger(section,'formheight',Varform.height);
    qlurl:=ReadString(section,'qlurl',qlurl);
    qlmethode:=ReadString(section,'qlmeth',qlmethode);
    qlinfo:=ReadString(section,'qlinfo',qlinfo);
    vsurl:=ReadString(section,'vsurl',vsurl);
    vsmethode:=ReadString(section,'vsmeth',vsmethode);
    vsinfo:=ReadString(section,'vsinfo',vsinfo);
end;
end;
inifile.free;
detail1.savecheckbox1:=Detailform.checkbox1.checked;
param.clear;
if paramcount>0 then begin
     for i:=1 to paramcount do param.Add(paramstr(i));
     ReadParam;
end;
ShowChart1.Enabled:=(not NoChart)and GetSkyChartInfo;  // initialize skychart value
started:=true;
DateTimepicker1change(sender);
CalculVar;
end;

procedure TVarForm.SortGrid1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var Acol,Arow : integer;
begin
if not started then exit;
Sortgrid1.MouseToCell(X,Y,Acol,Arow);
if Arow=0 then sortgrid1.TopRow:=1;
if (Arow<=0)or(trim(Sortgrid1.cells[0,arow])='') then exit;
case button of
mbLeft  : begin
          CurrentRow:=Arow;
          Detail1.current:=ARow;
          DetailForm.ShowModal;
          end;
mbRight : begin
          CurrentRow:=Arow;
          popupmenu1.popup(mouse.cursorpos.x,mouse.cursorpos.y);
          end;
end;
end;

procedure TVarForm.Setting1Click(Sender: TObject);
begin
OptForm.showmodal;
chdir(appdir);
end;

procedure TVarForm.FormClose(Sender: TObject; var Action: TCloseAction);
var  inifile : Tinifile;
     section : string;
begin
inifile:=Tinifile.create(appdir+'puls.ini');
section:='Default';
with inifile do begin
    WriteString(section,'fname',fname);
    WriteInteger(section,'dateformat',Radiogroup1.itemindex);
    WriteInteger(section,'obstype',OptForm.Radiogroup1.itemindex);
    WriteInteger(section,'obsformat',OptForm.Radiogroup4.itemindex);
    WriteInteger(section,'obspgm',OptForm.Radiogroup5.itemindex);
    WriteInteger(section,'onlinedata',OptForm.Radiogroup6.itemindex);
    WriteString(section,'pcobs',OptForm.FilenameEdit8.text);
    WriteString(section,'pcobscaption',pcobscaption);
    WriteString(section,'faavsosum',OptForm.FilenameEdit6.text);
    WriteString(section,'faavsoql',OptForm.FilenameEdit7.text);
    WriteString(section,'faavsojd',OptForm.FilenameEdit0.text);
    WriteString(section,'faavsout',OptForm.FilenameEdit1.text);
    WriteString(section,'fvsnet',OptForm.FilenameEdit2.text);
    WriteString(section,'dafoev',OptForm.DirectoryEdit1.text);
    WriteString(section,'freeformat',OptForm.FilenameEdit4.text);
    WriteString(section,'fobs',OptForm.FilenameEdit3.text);
    WriteString(section,'skychartprof',OptForm.FilenameEdit5.text);
    WriteString(section,'namepos',OptForm.Edit1.text);
    WriteString(section,'datepos',OptForm.Edit2.text);
    WriteString(section,'magpos',OptForm.Edit3.text);
    WriteInteger(section,'datetype',OptForm.Radiogroup2.itemindex);
    WriteInteger(section,'formattype',OptForm.Radiogroup3.itemindex);
    WriteString(section,'aavsochartdir',Optform.DirectoryEdit2.Text);
    WriteBool(section,'followcurve',Detail1.SaveCheckbox1);
    WriteBool(section,'plotobs',DetailForm.Checkbox2.Checked);
    WriteBool(section,'owncolor',DetailForm.Checkbox3.Checked);
    WriteBool(section,'plotql',DetailForm.Checkbox4.Checked);
    WriteBool(section,'plotgroup',DetailForm.Checkbox5.Checked);
    WriteString(section,'observer',OptForm.Edit4.text);
    WriteInteger(section,'color1',DetailForm.Shape1.Brush.Color);
    WriteInteger(section,'color2',DetailForm.Shape2.Brush.Color);
    WriteInteger(section,'color3',DetailForm.Shape3.Brush.Color);
    WriteInteger(section,'color4',DetailForm.Shape4.Brush.Color);
    WriteInteger(section,'color5',DetailForm.Shape5.Brush.Color);
    WriteInteger(section,'color6',DetailForm.Shape6.Brush.Color);
    WriteInteger(section,'color7',DetailForm.Shape7.Brush.Color);
    WriteInteger(section,'color8',DetailForm.Shape8.Brush.Color);
    WriteInteger(section,'color9',DetailForm.Shape9.Brush.Color);
    WriteInteger(section,'color10',DetailForm.Shape10.Brush.Color);
    WriteInteger(section,'formtop',Varform.top);
    WriteInteger(section,'formleft',Varform.left);
    WriteInteger(section,'formwidth',Varform.width);
    WriteInteger(section,'formheight',Varform.Height);
    WriteString(section,'qlurl',qlurl);
    WriteString(section,'qlmeth',qlmethode);
    WriteString(section,'qlinfo',qlinfo);
    WriteString(section,'vsurl',vsurl);
    WriteString(section,'vsmeth',vsmethode);
    WriteString(section,'vsinfo',vsinfo);
end;
inifile.free;
if StartedByVarobs then PostMessage(findwindow(nil,Pchar(skychartcaption)),WM_QUIT,0,0)   // close skychart (use WM_CLOSE for close prompt)
else begin
  CielHnd:=findwindow(nil,Pchar(skychartcaption));
  SendMessage(CielHnd, WM_SYSCOMMAND, SC_MINIMIZE, 0);
end;
end;

procedure TVarForm.Print1Click(Sender: TObject);
begin
try
screen.cursor:=crhourglass;
SortGrid1.PrintOptions.PageTitle:='Variables stars '+datim+bl;
SortGrid1.PrintOptions.Copies:=1;
SortGrid1.PrintOptions.Fromrow:=1;
SortGrid1.PrintOptions.Torow:=SortGrid1.RowCount-1;
SortGrid1.Print;
finally
chdir(appdir);
screen.cursor:=crdefault;
end;

end;

procedure TVarForm.Printersetup1Click(Sender: TObject);
begin
PrinterSetupDialog1.execute;
end;

procedure TVarForm.DateTimePicker1Change(Sender: TObject);
var y1,m1,d1 : word;
    hm : double;
    buf,buf1 : string;
begin
if lockdate then begin lockdate:=false; exit; end;
getdate(DateTimePicker1.date,y1,m1,d1);
hm:=frac(varform.datetimepicker2.time);
buf1:=format('%.4d%.2d%.2d',[y1,m1,d1]);
str(hm:1:4,buf);
lockdate:=true;
edit2.text:=buf1+copy(buf,2,9);
str(jd(y1,m1,d1,hm*24):9:4,buf);
lockdate:=true;
edit1.text:=buf;
edit1.color:=clWindow;
edit2.color:=clWindow;
Application.processmessages;
lockdate:=false;
end;

procedure TVarForm.Lightcurve1Click(Sender: TObject);
begin
Detail1.current:=CurrentRow;
DetailForm.ShowModal;
end;

Function InitConv : boolean;
begin
result:=false;
varform.ddeclientconv1.CloseLink;
with VarForm do if ddeclientconv1.SetLink('ciel','DdeSkyChart') then begin   // initialize conversation
 ddeclientitem1.DdeItem:='DdeData';
 result:=true;
end;
end;

procedure TVarForm.Timer1Timer(Sender: TObject);
begin
Timer1.Enabled:=false;                            // stop timer to avoid multiple call
if SkyChartRunning then begin                     // is app running
   sleep(2000);                                   // a litle more time to initialize
   skychartok:=Initconv;                          // start communication
   if not skychartok then Timer1.Enabled:=true;   // if not ok restart timer
end
else Timer1.Enabled:=true;
end;

Procedure InitSkyChart;
var param : string;
begin
skychartok := SkyChartRunning;     // is app already running
if not SkyChartok then begin
       if trim(optform.FilenameEdit5.text)='' then param:=''
       else param:='-c '+optform.FilenameEdit5.text;
       param:=param+' -f "CAT: 4 ID:'+trim(VarForm.SortGrid1.Cells[0,currentrow])+'"';
       StartSkyChart(param);
       VarForm.Timer1.Enabled:=true; // wait app start
       StartedByVarobs:=true;
       end
else begin
   skychartok:=Initconv;         // otherwise start communication directely
   if not skychartok then VarForm.Timer1.Enabled:=true;  // if not ok restart timer
end;

end;

Procedure DrawSkyChart;
var buf : string;
begin
InitConv;
buf := 'FIND CAT: 4 ID:'+trim(VarForm.SortGrid1.Cells[0,currentrow]);
CielHnd:=findwindow(nil,Pchar(skychartcaption));
SendMessage(CielHnd, WM_SYSCOMMAND, SC_RESTORE, 0);
SetForegroundWindow(CielHnd);
VarForm.ddeClientConv1.PokeData('DdeData',Pchar(buf));   // locate an object
sleep(1000);
end;

procedure TVarForm.ShowChart1Click(Sender: TObject);
begin
skychartok := SkyChartRunning;     // is app already running
if not skychartok then InitSkyChart;
DrawSkyChart;
end;

procedure TVarForm.Editcurrentfile1Click(Sender: TObject);
var i : integer;
begin
i:=ExecuteFile(fname, '', '', SW_SHOWNOACTIVATE);
chdir(appdir);
if i<=32 then showmessage('Error '+inttostr(i)+'. Please verify that file "'+fname+'" exist and associate it with your favorite text editor.');
end;

procedure TVarForm.Editobservationfile1Click(Sender: TObject);
var i : integer;
begin
i:=ExecuteFile(OptForm.FilenameEdit3.FileName, '', '', SW_SHOWNOACTIVATE);
chdir(appdir);
if i<=32 then showmessage('Error '+inttostr(i)+'. Please verify that file "'+OptForm.FilenameEdit3.FileName+'" exist and associate it with your favorite text editor.');
end;

procedure RunPCObs;
var nom,id : string ;
    pcobshnd : Thandle;
    ok : boolean;
    i : integer;
begin
nom:=trim(varform.SortGrid1.Cells[0,currentrow]);
id:=trim(varform.SortGrid1.Cells[1,currentrow]);
if id='' then clipboard.settextbuf(pchar(nom))
         else clipboard.settextbuf(pchar(id));
pcobshnd:=findwindow(nil,Pchar(pcobscaption)) ;
ok:= pcobshnd <> 0 ;
if ok then begin
   SendMessage(pcobshnd, WM_SYSCOMMAND, SC_RESTORE, 0);
   SetForegroundWindow(pcobshnd);
end else begin
   i:=ExecuteFile(OptForm.FilenameEdit8.FileName, '', '', SW_SHOWNOACTIVATE);
   chdir(appdir);
   if i<=32 then showmessage('Error '+inttostr(i)+'. Please verify that PCObs program is installed at location : '+OptForm.FilenameEdit8.FileName);
end;
end;

procedure TVarForm.Newobservation1Click(Sender: TObject);
begin
case Optform.radiogroup5.itemindex of
0 : begin
    ObsUnit.current:=CurrentRow;
    ObsForm.Showmodal;
    chdir(appdir);
    end;
1 : begin
    RunPCObs;
    end;
end;
end;

procedure TVarForm.Content1Click(Sender: TObject);
begin
executefile('varobs.html','',appdir,SW_SHOWNOACTIVATE);
end;

procedure TVarForm.BitBtn3Click(Sender: TObject);
begin
if bitbtn3.caption='Search' then begin
   sortgrid1.SearchOptions.Filtered:=false;
   sortgrid1.SearchOptions.SearchCol:=0;
   sortgrid1.SearchOptions.SearchText:=edit4.text;
   sortgrid1.SearchOptions.CaseSensitive:=false;
   if sortgrid1.Findfirst then bitbtn3.Caption:='Next'
                          else Showmessage('Not found');
end else begin
   if sortgrid1.FindNext then bitbtn3.Caption:='Next'
                         else begin
                              bitbtn3.Caption:='Search';
                              Showmessage('Not found');
                         end;
end;
end;

procedure TVarForm.About1Click(Sender: TObject);
begin
  splash := Tsplash.create(application);
  splashunit.SplashTimer:=false;
  splash.showmodal;
  splash.free;
end;

procedure TVarForm.PrepareLPVBulletin1Click(Sender: TObject);
begin
executefile('bulletin.exe','',appdir,SW_SHOWNOACTIVATE);
end;

procedure TVarForm.Createobservingplan1Click(Sender: TObject);
begin
executefile('copyplan.exe','',appdir,SW_SHOWNOACTIVATE);
end;

procedure TVarForm.AAVSOwebpage1Click(Sender: TObject);
begin
executefile('http://www.aavso.org','',appdir,SW_SHOWNOACTIVATE);
end;

procedure TVarForm.AAVSOChart1Click(Sender: TObject);
var i : integer;
    buf,id, chartlist: string;
    f: textfile;
begin
chartlist:='';
chdir(appdir);
assignfile(f,'united.txt');
reset(f);
try
repeat
  readln(f,buf);
  i:=pos('#',buf);
  id:=trim(copy(buf,1,i-1));
  if id=VarForm.SortGrid1.Cells[1,currentrow] then begin
     i:=lastdelimiter('#',buf);
     chartlist:=trim(copy(buf,i+1,9999));
     break;
  end;
until eof(f);
finally
closefile(f);
end;
chartform.chartlist:=chartlist;
chartform.chartdir:=Optform.DirectoryEdit2.Text;
chartform.ShowModal;
end;

end.
